Controllers/AuthController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using MiProyecto.DB.Maps;
using MiProyecto.DB;
using MiProyecto.Models;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using System.Text;
using Microsoft.Extensions.Configuration;
using System.Security.Claims;
using System.Security.Cryptography;



namespace MiProyecto.Controllers
{
    public class AuthController : Controller
    {
        private AppProyectoContext context;
        private IConfiguration configuration;
        public AuthController(AppProyectoContext context, IConfiguration configuration)
        {
            this.context = context;
            this.configuration = configuration;
        }

        [HttpGet]
        public IActionResult Login()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Login(string username, string password)
        {
            var hash = CreateHash(password);
            var user = context.Usuarios
                .FirstOrDefault(o => o.Username == username && o.Password == hash);

            if (user == null)
            {
                TempData["AuthMessage"] = "Usuario o Password incorrecto";
                HttpContext.Response.StatusCode = 400;

                return View("Login");
            }

            // Autenticar
            var claims = new List<Claim> {
                new Claim(ClaimTypes.Name, user.Username),
            };

            var claimsIdentity = new ClaimsIdentity(claims, CookieAuthenticationDefaults.AuthenticationScheme);
            var claimsPrincipal = new ClaimsPrincipal(claimsIdentity);

            HttpContext.SignInAsync(claimsPrincipal);
            if (user.Username == "admin") {
                return RedirectToAction("Index", "Admin");
            }
            return RedirectToAction("CatalogoCursos", "Home");
        }

     
        [HttpGet]
        public IActionResult Logout()
        {
            HttpContext.SignOutAsync();
            return RedirectToAction("Login");
        }

        [HttpGet]
        public string Create(string password)
        {
            return CreateHash(password);
        }

        private string CreateHash(string input)
        {
            input += configuration.GetValue<string>("Key");
            var sha = SHA512.Create();

            var bytes = Encoding.Default.GetBytes(input);
            var hash = sha.ComputeHash(bytes);

            return Convert.ToBase64String(hash);
        }


        [HttpGet]
        public ActionResult Registrar()
        {
            return View();
        }
      
        [HttpPost]
        public ActionResult Registrar(Usuario usuario, string PasswordConf)
        {
            var usuarios = context.Usuarios.ToList();
            foreach (var item in usuarios)
            {
                if (item.Email == usuario.Email)
                    ModelState.AddModelError("Email", "Este Email ya esta registrado !");
                if (item.Username == usuario.Username)
                    ModelState.AddModelError("Username", "Este usuario ya esta registrado !");
            }

            if (usuario.Password != PasswordConf) // <-- para convalidar contraseña y confirmacion de contraseña
                   ModelState.AddModelError("passwordNew", "Las contraseñas no coinciden !");
           
                if (ModelState.IsValid)
                {
                usuario.Email = usuario.Email;
                usuario.Password = CreateHash(PasswordConf);
                    context.Usuarios.Add(usuario);
                    context.SaveChanges();
                    return RedirectToAction("Login");
                }
                return View("Registrar", usuario);
            }
        }
    }

Controllers/CursosController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using MiProyecto.DB;
using MiProyecto.Models;

namespace MiProyecto.Controllers
{
    // La clase cursoDetalle solo tiene un Curso y una lista de CursoProfesor
    // Dentro de cursoProfesor yo puedo acceder a cada uno de los profesores
    public class CursoDetalle
    {
        public Curso Curso { get; set; }
        public bool Matriculado { get; set; }
        public List<Profesor> Profesores { get; set; }
    }
    
    public class CursosController : Controller
    {
        private AppProyectoContext context;

        public CursosController(AppProyectoContext context)
        {
            this.context = context;
        }

        
        public IActionResult Detalle(int id)
        {
            ViewBag.usuario = GetUsuario();
            ViewBag.progreso = ObtenerProgreso(id);
            // Obtengo el curso por su ID
            var curso = context.Cursos.FirstOrDefault(o => o.Id == id);

            // Obtengo todos los cursosDetalle que coincidan con el CursoID
            var cursoProfesores = context.CursoProfesores.Where(o => o.CursoId == curso.Id).Include(o => o.Profesor).ToList(); //Envia como null

            var profesores = new List<Profesor>();

            foreach (var cursoProfesor in cursoProfesores)
            {
                var profesor = context.Profesores.FirstOrDefault(o => o.Id == cursoProfesor.ProfesorId);
                profesores.Add(profesor);
            }

            // Creo un objeto de la clase CursoDetalle para enviar por Model los datos
            var cursoDetalle = new CursoDetalle
            {
                Curso = curso,
                Profesores = profesores, Matriculado = false
            };

            //----------
            var usuario = GetUsuario();
            if(usuario != null)
            {
                var matriculado = context.Inscribirses.Where(o => o.IdCurso == curso.Id && o.IdUser == GetUsuario().Id).FirstOrDefault();

                if (matriculado != null)
                {
                    cursoDetalle.Matriculado = true;
                    ViewBag.MICU = cursoDetalle.Matriculado;
                }
                else
                    ViewBag.MICU = false;
            }
            else
                ViewBag.MICU = false;

            return View(cursoDetalle);
        }
        [HttpGet]
        public ActionResult Matricular(int id)
        {
            var misCursos = context.Inscribirses.ToList();

            foreach (var item in misCursos)
            {
                if (item.IdCurso == id && item.IdUser == GetUsuario().Id)
                {
                    TempData["Error"] = "Curso matriculado";
                    ModelState.AddModelError("Error","Matriculado");
                }
            }
            if (ModelState.IsValid)
            {
                var matricula = new Inscribirse();

                matricula.IdCurso = id;
                matricula.IdUser = GetUsuario().Id;
                context.Inscribirses.Add(matricula);
                context.SaveChanges();
                return RedirectToAction("CatalogoCursos", "Home");
            }
            return RedirectToAction("CatalogoCursos", "Home");
        }

        private Usuario GetUsuario()
        {
            var claim = HttpContext.User.Claims.FirstOrDefault();
            if (claim != null)
            {
                var user = context.Usuarios.Where(o => o.Username == claim.Value).FirstOrDefault();
                return user;
            }

            return null;
        }

        [Authorize]
        public IActionResult MisCursos()
        {

            ViewBag.usuario = GetUsuario();
            var cursos = context.Inscribirses.Include(o=>o.Curso)
                .ThenInclude(o=>o.CursoProfesores)
                .ThenInclude(o=>o.Profesor)
                .Where(o => o.IdUser == GetUsuario().Id).ToList();

            return View(cursos);
        }

        
        private int ObtenerProgreso(int idCurso) {
            var capitulos = context.Capitulos.Where(o => o.CursoId == idCurso).Include(o => o.Lecciones).ToList();
            var progreso = 0;
            if (capitulos.Count == 0)
            {
                return 0;
            }
            foreach (var capitulo in capitulos)
            {
                progreso += ObtenerProgresoCapitulo(capitulo);
            }
            return progreso/capitulos.Count;
        }
        private int ObtenerProgresoCapitulo(Capitulo capitulo)
        {
            var usuario = GetUsuario();
            var lecciones = context.Lecciones.Where(o => o.CapituloId == capitulo.Id).ToList();
            var leccionesCompletadas = 0;
            var leccionCompletada = new ClaseTomada();
            if (lecciones.Count() == 0)
            {
                return 0;
            }
            foreach (var leccion in lecciones)
            {
                leccionCompletada = context.ClaseTomadas.
                    Where(o => o.IdLeccion == leccion.Id && o.IdUser == usuario.Id).
                    FirstOrDefault();
                if (leccionCompletada != null)
                {
                    leccionesCompletadas++;
                }
            }
            return (leccionesCompletadas * 100 / lecciones.Count());
        }

    }
}

Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />


    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - MiProyecto</title>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=Edge">
    <meta name="description" content="">
    <meta name="keywords" content="">
    <meta name="author" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

    <link rel="stylesheet" href="~/css/bootstrap.min.css">
    <link rel="stylesheet" href="~/css/font-awesome.min.css">
    <link rel="stylesheet" href="~/css/owl.carousel.css">
    <link rel="stylesheet" href="~/css/owl.theme.default.min.css">

    <!-- MAIN CSS -->
    <link rel="stylesheet" href="~/css/templatemo-style.css">
    
</head>
<body id="top" data-spy="scroll" data-target=".navbar-collapse" data-offset="50">
    <section class="preloader">
        <div class="spinner">

            <span class="spinner-rotate"></span>

        </div>
    </section>

    <!-- MENU -->
    <section class="navbar custom-navbar navbar-fixed-top" role="navigation">
        <div class="container">

            <div class="navbar-header">
                <button class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="icon icon-bar"></span>
                    <span class="icon icon-bar"></span>
                    <span class="icon icon-bar"></span>
                </button>

                <!-- lOGO TEXT HERE -->
                <a href="#" class="navbar-brand"><img width="150" src="/img/logo.jpg" alt="logo"> </a>
            </div>

            <!-- MENU LINKS -->
            <div class="collapse navbar-collapse">
                <ul class="nav navbar-nav navbar-nav-first">
                    <li><a class="smoothScroll" asp-controller="Home" asp-action="Index">Home</a></li>
                    <li><a class="smoothScroll" asp-controller="Home" asp-action="CatalogoCursos">Cursos</a></li>
                    @if (ViewBag.usuario != null)
                    {
                        <li><a class="smoothScroll" asp-controller="Cursos" asp-action="MisCursos">Mis cursos</a></li>

                    }
                </ul>

                <ul class="nav navbar-nav navbar-right">
                    @if (ViewBag.usuario != null)
                    {
                    <li role="presentation" class="dropdown">
                            
                        <a class="dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">
                            <img src="https://www.creartuavatar.com/images/m7.svg" width="35" height="35" class="img-circle">
                            @ViewBag.usuario.Username <span class="caret"></span>
                        </a>
                        <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">
                            <li><a asp-area="" asp-controller="Auth" asp-action="Logout">Salir</a></li>
                        </ul>
                            
                       
                    </li> 
                    }
                    else
                    {
                    <li>
                        <a asp-area="" asp-controller="Auth" asp-action="Login"> Iniciar Sesión</a>
                    </li>
                       }
                </ul>

            </div>

        </div>
    </section>


    <section id="home">
        <div class="container" >
            <main role="main" class="">
                <br />
                @RenderBody()
            </main>
        </div>

    </section>
    
    <footer id="footer" class="border-top text-muted">
        <div class="container">
            &copy; 2021 - MiProyecto - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>

    <script src="~/js/jquery.js"></script>
    <script src="~/js/bootstrap.min.js"></script>
    <script src="~/js/owl.carousel.min.js"></script>
    <script src="~/js/smoothscroll.js"></script>
    <script src="~/js/custom.js"></script>

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>